// ===========================================================================
// File: W I N S I N K . H
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//
// Copyright 1995-2002 Microsoft Corporation.  All Rights Reserved.

#ifndef _WinSink_h_
#define _WinSink_h_

class MyParser;

class CWinSink : public IDispatch
{
public:
	CWinSink() : m_pWin(NULL), m_dwRef(1),			
			m_dwCookie(0), m_pCP(NULL)		
	{
	}

	~CWinSink()
	{
	}

	HRESULT setupConnection(IHTMLDocument2* pDoc2, MyParser* pApp);

	HRESULT Init(IHTMLWindow2* pWin);
	HRESULT Uninit();


	// IUnknown methods
    STDMETHOD(QueryInterface)(REFIID riid, LPVOID* ppv);
    STDMETHOD_(ULONG, AddRef)();
    STDMETHOD_(ULONG, Release)(); 

	// IDispatch method
	STDMETHOD(GetTypeInfoCount)(UINT* pctinfo)
			{ return E_NOTIMPL; }

	STDMETHOD(GetTypeInfo)(UINT iTInfo,
            LCID lcid,
            ITypeInfo** ppTInfo)
			{ return E_NOTIMPL; }

	STDMETHOD(GetIDsOfNames)(REFIID riid,
            LPOLESTR* rgszNames,
            UINT cNames,
            LCID lcid,
            DISPID* rgDispId)
			{  return E_NOTIMPL; }
        
	STDMETHOD(Invoke)(DISPID dispIdMember,
            REFIID riid,
            LCID lcid,
            WORD wFlags,
            DISPPARAMS __RPC_FAR *pDispParams,
            VARIANT __RPC_FAR *pVarResult,
            EXCEPINFO __RPC_FAR *pExcepInfo,
            UINT __RPC_FAR *puArgErr);

protected:
	IHTMLWindow2* m_pWin;
	DWORD m_dwRef;
	LPCONNECTIONPOINT m_pCP;
	DWORD m_dwCookie;

};

#endif